
var ids = {};

function init_handlers()
{
  var handlers = [
    // id                event    handler function
    ["dialog.add",      "click",  add_click],
    ["dialog.delete",   "click",  delete_click],
    ["dialog.keywords", "select", keywords_select],
    ["dialog.related",  "select", related_select]
  ];

  for (var i = 0; i < handlers.length; i++)
  {
    var obj = window.document.getElementById(handlers[i][0]);
    obj.addEventListener(handlers[i][1], handlers[i][2], false);
    ids[handlers[i][0]] = obj;
  }
  ids["dialog.keyword"] = window.document.getElementById("dialog.keyword");
}

window.addEventListener("load",init_handlers, true);

function add_click(ev)
{
  var listbox = ids["dialog.keywords"];
  var textbox = ids["dialog.keyword"];
  var items = listbox.childNodes.length; // workaround

  if ( textbox.value.replace(/^ *$/,"") == "" )
    return;	// don't add spaces as keywords

  for (var i = 0; i < items; i++)
  {
    if ( listbox.getItemAtIndex(i).label == textbox.value )
      return;	// already exists
  }

  listbox.appendItem(textbox.value, textbox.value);
  listbox.scrollToIndex(items > 1 ? items - 2 : items);
}
  
function delete_click(ev)
{
  var listbox = ids["dialog.keywords"];
  var textbox = ids["dialog.keyword"];
  var items = listbox.childNodes.length; // workaround

  for (var i = 0; i < items; i++)
    if ( listbox.getItemAtIndex(i).label == textbox.value )
    {
      listbox.removeItemAt(i);
      return;
    }
}
  
function keywords_select(ev)
{
  var listbox = ids["dialog.keywords"];
  var textbox = ids["dialog.keyword"];
  var tree    = ids["dialog.related"];
  var items   = document.getElementsByTagName('treecell');
  var item    = null;
  var selected = null;

  try { listbox.currentItem.label; }
  catch (e) { return; }

  textbox.value = listbox.currentItem.label;

  for (var i = 0; i < items.length; i++)
  {
    if (items.item(i).getAttribute("label") == textbox.value)
    {
      item = items.item(i).parentNode.parentNode;
      break;
    }
  }

  if ( item )
  {
    selected = item;
    if ( tree.view.getIndexOfItem(item) == -1 )
    {
      while (item.tagName != "tree")
      {
        if (item.getAttribute("container") != "")
	{
	  item.setAttribute("open","true");
	}
	item = item.parentNode.parentNode;
      }
    }
    // tree.currentIndex = tree.view.getIndexOfItem(selected);
    // only supplies the focus,not the selection.
    i = tree.view.getIndexOfItem(selected);
    tree.treeBoxObject.selection.select(i);
    tree.treeBoxObject.ensureRowIsVisible(i);
  }
}

function related_select(ev)
{
  var textbox = ids["dialog.keyword"];
  var tree    = ids["dialog.related"];

  textbox.value = tree.view.getCellText(tree.currentIndex, "tree.all");
}
  
